SystemOrganization addCategory: #'MDProfiler-Core'!

Profiler subclass: #MProfiler
	instanceVariableNames: 'inputs dimensions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MDProfiler-Core'!

!MProfiler class methodsFor: 'as yet unclassified' stamp: ''!
spyClassForPackage
	^ MPackage! !

OrderedCollection subclass: #MVector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MDProfiler-Core'!

!MVector class methodsFor: 'as yet unclassified' stamp: ''!
values: t1 
	| t2 |
	t2 := self new.
	t2 addAll: t1.
	^ t2! !

!MVector methodsFor: 'as yet unclassified' stamp: ''!
= t1 
	| t2 |
	self class = t1 class
		ifTrue: [self size = t1 size
				ifTrue: [t2 := 1.
					self
						do: [:t4 | 
							t4
									= (t1 at: t2)
								ifFalse: [^ false].
							t2 := t2 + 1].
					^ true]].
	^ false! !

MethodSpy subclass: #MMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MDProfiler-Core'!

PackageSpy subclass: #MPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MDProfiler-Core'!

!MPackage class methodsFor: 'as yet unclassified' stamp: ''!
spyClassForClass
	^ MClass! !

ClassSpy subclass: #MClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MDProfiler-Core'!

!MClass class methodsFor: 'as yet unclassified' stamp: ''!
spyClassForMethod
	^ MMethod! !

Object subclass: #MBuilder
	instanceVariableNames: 'inputs dimensions packagePattern'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MDProfiler-Core'!

!MBuilder methodsFor: 'as yet unclassified' stamp: ''!
combinationsOf: t1 
	| t2 t3 t4 |
	t4 := OrderedCollection new.
	t1 isEmpty
		ifTrue: [^ t4].
	t3 := t1 first.
	t1 removeFirst.
	t2 := self combinationsOf: t1.
	t3 values
		do: [:t5 | t2 isEmpty
				ifTrue: [t4 add: (OrderedCollection new add: t5;
							 yourself)]
				ifFalse: [t2
						do: [:t6 | t4 add: (OrderedCollection new add: t5;
									 addAll: t6;
									 yourself)]]].
	^ t4! !

!MBuilder methodsFor: 'as yet unclassified' stamp: ''!
define: t1 named: t2 
	| t3 |
	t3 := self perform: t1.
	t3 name: t2.
	^ t3! !

!MBuilder methodsFor: 'as yet unclassified' stamp: ''!
define: t1 named: t2 with: t3 
	| t4 |
	t4 := self define: t1 named: t2.
	t4 values: t3.
	^ t4! !

!MBuilder methodsFor: 'as yet unclassified' stamp: ''!
dimension
	| t1 |
	t1 := MDimension new.
	inputs add: t1.
	^ t1! !

!MBuilder methodsFor: 'as yet unclassified' stamp: ''!
execute: t1 
	| t2 t3 t4 |
	t2 := MResultSet new.
	t3 := OrderedCollection new.
	(self combinationsOf: inputs copy)
		do: [:t5 | 
			| t6 |
			t6 := [t1 valueWithArguments: t5]
						on: Error
						do: [].
			t2 key: t5 value: t6].
	^ t2! !

!MBuilder methodsFor: 'as yet unclassified' stamp: ''!
getTimeAndCallGraph
	^ false! !

!MBuilder methodsFor: 'as yet unclassified' stamp: ''!
initialize
	super initialize.
	dimensions := OrderedCollection new.
	inputs := OrderedCollection new! !

!MBuilder methodsFor: 'as yet unclassified' stamp: ''!
input
	| t1 |
	t1 := MInput new.
	inputs add: t1.
	^ t1! !

!MBuilder methodsFor: 'as yet unclassified' stamp: ''!
input: t1 with: t2 
	inputs add: (MInput named: t1;
			 values: t2;
			 yourself)! !

!MBuilder methodsFor: 'as yet unclassified' stamp: ''!
inputs
	^ inputs! !

!MBuilder methodsFor: 'as yet unclassified' stamp: ''!
inputsOf: t1 
	| t2 |
	t2 := inputs
				select: [:t3 | t3 name = t1].
	t2 size = 0
		ifTrue: [^ nil].
	^ t2 anyOne values! !

!MBuilder methodsFor: 'as yet unclassified' stamp: ''!
profile: t1 inPackagesMatching: t2 
	^ self spyProfiler profile: t1 inPackagesMatching: t2! !

!MBuilder methodsFor: 'as yet unclassified' stamp: ''!
spyProfiler
	^ MProfiler! !

Object subclass: #MDimension
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MDProfiler-Core'!

!MDimension class methodsFor: 'as yet unclassified' stamp: ''!
named: t1 
	| t2 |
	t2 := self new.
	t2 name: t1.
	^ t2! !

!MDimension methodsFor: 'as yet unclassified' stamp: ''!
name
	^ name! !

!MDimension methodsFor: 'as yet unclassified' stamp: ''!
name: t1 
	name := t1! !

Object subclass: #MInput
	instanceVariableNames: 'name values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MDProfiler-Core'!

!MInput class methodsFor: 'as yet unclassified' stamp: ''!
named: t1 
	| t2 |
	t2 := self new.
	t2 name: t1.
	^ t2! !

!MInput methodsFor: 'as yet unclassified' stamp: ''!
addValue: t1 
	values add: t1! !

!MInput methodsFor: 'as yet unclassified' stamp: ''!
initialize
	super initialize.
	values := OrderedCollection new! !

!MInput methodsFor: 'as yet unclassified' stamp: ''!
name
	^ name! !

!MInput methodsFor: 'as yet unclassified' stamp: ''!
name: t1 
	name := t1! !

!MInput methodsFor: 'as yet unclassified' stamp: ''!
values
	^ values! !

!MInput methodsFor: 'as yet unclassified' stamp: ''!
values: t1 
	values := t1! !

Object subclass: #MResultSet
	instanceVariableNames: 'dictionary size keys values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MDProfiler-Core'!

!MResultSet methodsFor: 'as yet unclassified' stamp: ''!
initialize
	super initialize.
	dictionary := Dictionary new.
	size := -1.
	keys := OrderedCollection new.
	values := OrderedCollection new! !

!MResultSet methodsFor: 'as yet unclassified' stamp: ''!
key: t1 value: t2 
	size < 0
		ifTrue: [size := t1 size]
		ifFalse: [t1 size = size
				ifFalse: [^ false]].
	keys
		add: (MVector values: t1).
	values add: t2.
	dictionary
		at: (MVector values: t1)
		put: t2.
	^ true! !

!MResultSet methodsFor: 'as yet unclassified' stamp: ''!
keys
	^ keys! !

!MResultSet methodsFor: 'as yet unclassified' stamp: ''!
maxValue: t1 
	^ values maxValue: t1! !

!MResultSet methodsFor: 'as yet unclassified' stamp: ''!
minValue: t1 
	^ values minValue: t1! !

!MResultSet methodsFor: 'as yet unclassified' stamp: ''!
of: t1 
	| t2 |
	t2 := t1 isCollection
				ifTrue: [t1]
				ifFalse: [OrderedCollection new add: t1;
						 yourself].
	^ dictionary
		at: (MVector values: t2)
		ifAbsent: []! !

!MResultSet methodsFor: 'as yet unclassified' stamp: ''!
values
	^ values! !
